<template>
  <div>
    <div class="modal-body-container">
      <div class="map-address-input">
        <label>Введите адрес точки или укажите его на карте</label>
        <span>
          {{ addressLocal }}
        </span>
      </div>
      <div class="map-address-actions">
        <ob-button
          type="primary"
          :mini="true"
          :disabled="!(!!coordsLocal)"
          label="Выбрать"
          @click.native="save"
        />
        <ob-button
          type="flat"
          label="Отмена"
          :mini="true"
          @click.native="$emit('close')"
        />
      </div>
    </div>
    <map-leaflet
      class="location-map"
      :map-id="mapId"
      :coords="coordsLocal"
      :disabled="disabled"
      @select-point="getAddressByCoordinates"
    />
  </div>
</template>

<script>
import MapLeaflet from './MapLeaflet'
import ObButton from 'common-components/src/obComponents/obButton';
import api from '@/api'

export default {
  name: 'ChangeCoords',
  components: {
    MapLeaflet,
    ObButton
  },
  props: {
    disabled: {
      type: Boolean,
      default: false
    },
    address: {
      type: Object,
      default: () => {}
    },
    mapId: {
      type: String
    }
  },
  data () {
    return {
      coordsStr: '',
      coordsLocal: {},
      locationName: '',
      addressLocal: {},
      engLocationName: ''
    }
  },
  watch: {
    address () {
      this.setAddressInfo()
    }
  },
  mounted () {
    this.setAddressInfo()
  },
  methods: {
    setAddressInfo () {
      if (this.address) {
        let coordinates = this.address.coordinates

        if (coordinates) {
          this.coordsLocal = {
            lat: coordinates.lat || coordinates[0],
            lon: coordinates.lon || coordinates[1]
          }
          this.locationName = this.address.label
          this.addressLocal = this.address.label
        }
      }
    },
    onChangeAddress (address) {
      let coordinates = { lat: address.coordinates[0], lon: address.coordinates[1] }
      this.getAddressByCoordinates(coordinates)
    },
    async getAddressByCoordinates (coordinates) {
      let address = await api.geocoder.getAddressByCoordinates({
        coordinates: coordinates.lat + ',' + coordinates.lon
      })
      console.log('click ->', coordinates, address);
      address.coordinates = coordinates
      this.coordsLocal = address.coordinates
      this.addressLocal = address.russian_address
      this.locationName = address.russian_address
      this.engLocationName = address.english_address
    },
    save () {
      this.$emit('on-change-address', {
        local: this.addressLocal,
        localRu: this.locationName,
        localEng: this.engLocationName,
        coordsLocal: this.coordsLocal
      })
      this.$emit('close')
    }
  }
}
</script>

<style lang="scss" scoped>
.modal-body-container {
  position: fixed;
  top: 20px;
  left: 20px;
  width: calc(100% - 40px);
  padding: 20px;
  box-shadow: 0px 4px 4px $components-ChangeCoords-modal_body_container_box-shadow;
  border-radius: 4px;
  z-index: 100;
  background-color: $components-ChangeCoords-modal_body_container_background_color;
  display: flex;
  align-items: center;
}

.map-address-actions {
  display: flex;
  align-items: center;
}

.location-map {
  .leaflet-container {
    cursor: auto;
    &.leaflet-drag-target {
      cursor: grabbing;
    }
  }
}
</style>
<style lang="scss">
.map-address-input {
  flex-grow: 1;
  position: relative;
  margin-right: 20px;

  .el-autocomplete {
    width: 100%;
  }

  label {
    position: absolute;
    top: 8px;
    left: 12px;
    font-size: 12px;
    z-index: 2;
  }

  .el-input__inner {
    height: 52px;
    padding: 8px 12px;
  }
}
</style>
